
#include <windows.h>
#include <tchar.h>

#define UNLHA_DLL
//#define UNZIP_DLL

typedef (*UNLHA)(HWND, LPCTSTR, LPTSTR ,DWORD); 
typedef WORD (WINAPI *FUNC)(VOID); 
typedef int (*UNZIP)(HWND, LPCTSTR, LPTSTR ,DWORD); 

const int ERR_DLL_NOT_FOUND = 101;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
					 LPTSTR lpszCmdLine, int nCmdShow)
{
#ifdef UNLHA_DLL
	// LHA.EXE
    HMODULE hDLL = ::LoadLibrary( _T("unlha.dll") ) ;

	if ( hDLL == NULL )
	{
		MessageBox(NULL, _T("UNLHA.DLL ܂"),
			_T("UNLHA.exe"), MB_ICONSTOP);
		return ERR_DLL_NOT_FOUND;
	}

    FUNC func = (FUNC)::GetProcAddress( hDLL, _T("UnlhaGetVersion") );
//    FUNC func = (FUNC)::GetProcAddress( hDLL, (LPTSTR)4 );
    if ( func )
    {
		DWORD dwVersion = (*func)();
    }

	static TCHAR outbuf[64*1024]={0};
    UNLHA unlha = (UNLHA)::GetProcAddress( hDLL, _T("Unlha") );
//    UNLHA unlha = (UNLHA)::GetProcAddress( hDLL, (LPTSTR)1 );
    if ( unlha )
    {
		int ret = (*unlha)(NULL, 
			lpszCmdLine, outbuf, sizeof(outbuf));
//		OutputDebugString(outbuf);
    }

	if(_tcslen(outbuf)!=0){
		MessageBox(NULL, outbuf, _T("UNLHAfilt"), MB_ICONSTOP);
	}

	::FreeLibrary( hDLL ) ;

#endif // UNLHA_DLL

#ifdef UNZIP_DLL

    HMODULE hDLL = ::LoadLibrary( _T("unzip.dll") ) ;

	if ( hDLL == NULL )
	{
		MessageBox(NULL, _T("UNZIP.DLL ܂"),
			_T("UNZIP.exe"), MB_ICONSTOP);
		return ERR_DLL_NOT_FOUND ;
	}

	FUNC func = (FUNC)::GetProcAddress( hDLL, _T("UnZipGetVersion") );
	if ( func )
	{
		DWORD dwVersion = (*func)();
	}

	static TCHAR outbuf[64*1024]={0};
	UNZIP unzip = (UNZIP)::GetProcAddress( hDLL, _T("UnZip") );
    if ( unzip )
    {
		int ret = (*unzip)(NULL,
			lpszCmdLine, 
			outbuf, sizeof(outbuf));
//		OutputDebugString(outbuf);
    }

	if(_tcslen(outbuf)!=0){
		MessageBox(NULL, outbuf, _T("UNLHAfilt"), MB_ICONSTOP);
	}

	::FreeLibrary( hDLL ) ;

#endif //UNZIP_DLL

	return 0;
}
